; ******************************************************
; BASIC .ASM template file for AVR
; ******************************************************

.include "C:\VMLAB\include\m16def.inc"

;   
;
.def  temp  =r16  ; 
.def  index =r17  ;  (  )
.def	whole	=r18	; 
.def	fract	=r19  ; 
.def  temp1 =r20  ;  
.def	data	=r21  ;    
.def	flag	=r22	; 

.equ	up	=0x03    ;   ,   ( 0-9)

.equ Tbeep = 0x03	;      

.equ Invertor_time = 0x05 ;  ,     3 

;  


;  
;
.ORG 0x000
reset:
   rjmp start

.ORG OVF1addr
	jmp Decr_current_timer
.ORG OVF0addr
	jmp Disp_drive


.ORG 0x02A

;*******************************************************
;         
;
start:
;  
	ldi temp, HIGH(RAMEND)
	out SPH, temp
	ldi temp, LOW(RAMEND)
	out SPL, temp
; 
;  ()
	ldi temp, 0x00
	out PORTA, temp
	ldi temp, 0xFF
	out DDRA, temp
;  ()
	ldi temp, 0x0F
	out PORTB, temp
	ldi temp, 0xFF
	out DDRB, temp
;  ( )
	cbi PORTC, 0
	sbi DDRC, 0
;  ()
	ldi temp, 0x00
	out DDRD, temp
	ldi temp, 0xFF
	out PORTD, temp

;*******************************************************
;   (   0)
	ldi temp, 0x00
	ldi XH, HIGH(T1_wh_s)
	ldi XL, LOW(T1_wh_s)
	st X, temp

	ldi XH, HIGH(T1_fr_s)
	ldi XL, LOW(T1_fr_s)
	st X, temp

	ldi XH, HIGH(T2_wh_s)
	ldi XL, LOW(T2_wh_s)
	st X, temp

	ldi XH, HIGH(T2_fr_s)
	ldi XL, LOW(T2_fr_s)
	st X, temp

	ldi XH, HIGH(T3_wh_s)
	ldi XL, LOW(T3_wh_s)
	st X, temp

	ldi XH, HIGH(T3_fr_s)
	ldi XL, LOW(T3_fr_s)
	st X, temp
	
; 

	ldi XH, HIGH(T1_wh_restore)
	ldi XL, LOW(T1_wh_restore)
	st X, temp

	ldi XH, HIGH(T1_fr_restore)
	ldi XL, LOW(T1_fr_restore)
	st X, temp

	ldi XH, HIGH(T2_wh_restore)
	ldi XL, LOW(T2_wh_restore)
	st X, temp

	ldi XH, HIGH(T2_fr_restore)
	ldi XL, LOW(T2_fr_restore)
	st X, temp

	ldi XH, HIGH(T3_wh_restore)
	ldi XL, LOW(T3_wh_restore)
	st X, temp

	ldi XH, HIGH(T3_fr_restore)
	ldi XL, LOW(T3_fr_restore)
	st X, temp

;
;*******************************************************
;        1 ( )
	ldi temp, 0x01
	ldi XH, HIGH(Current_timer)
	ldi XL, LOW(Current_timer)
	st X, temp
	
	ldi temp, 0x00
	ldi XH, HIGH(Current_cycle)
	ldi XL, LOW(Current_cycle)
	st X, temp
;


;*******************************************************
;  0,   ~4    
;     ~250  ( )
;   1  0x82 -> 0xFF
	ldi temp, 0x82
	out TCNT0, temp
	ldi temp, (1<<TOIE0)
	out TIMSK, temp		;    0
	ldi temp, (1<<CS01)
	out TCCR0, temp		;  0
	sei						;  


;*******************************************************
;  1,   - 100 .
;       
;  1     
T1_init:
	ldi temp, 0xCF
	out TCNT1H, temp
	ldi temp, 0x2B
	out TCNT1L, temp

in temp, TIMSK
ori temp, (1<<TOIE1)
out TIMSK, temp


	
;
;*******************************************************
;   ( =0)
	ldi flag, 0x00

;*******************************************************
;     ,   ,  
;  
ready:

		call Read_keys
   	cpi data, 0xFE
   	breq incr_T1	;  . 3 ( )     1
   	
   	cpi data, 0xFD
   	breq decr_T1	;  . 5 ( )     1
   	
   	cpi data, 0xFB
   	breq incr_T2   ;
   	
   	cpi data, 0xF7
   	breq decr_T2
   	
   	cpi data, 0xEF
   	breq incr_T3
   	
   	cpi data, 0xDF
   	breq decr_T3
   	
   	cpi data, 0xBF
   	breq Timer_run 	;,    
   	
   	cpi data, 0x7F
   	breq Timer_stop
   	
   	jmp no_key			;   

;   1
;    = 1
incr_T1:
	call incr_T1sbr	; ,    1  0,1  ( )
jmp no_key


decr_T1:
	call decr_T1sbr   ; ,    1  0,1  ( )
jmp no_key

incr_T2:
	call incr_T2sbr	;  2  3 
jmp no_key



decr_T2:
	call decr_T2sbr
jmp no_key


incr_T3:
	call incr_T3sbr
jmp no_key


decr_T3:
	call decr_T3sbr
jmp no_key


Timer_run:
; ,   ,     


	cpi flag, 0x01
	brne no_key
   ldi XH, HIGH(Current_timer)
   ldi XL, LOW(Current_timer)
   ldi temp, 0x01
   st X, temp						;  

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   
call Timer_restore
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


	jmp wait


Timer_stop:



no_key:

jmp ready

;*******************************************************
;     
;  
;      
; .
;    ,  
;    .
wait:
;  1
	ldi temp, (1<<CS11)
	out TCCR1B, temp				; !
;   
;,   1   0
;  ,      
T1_start:
	sbi PORTB, 4 ;(.  1)
	;    1
	
		ldi XH, HIGH(T1_wh_s)
		ldi XL, LOW(T1_wh_s)
		ld temp, X
		
		ldi XH, HIGH(T1_fr_s)
		ldi XL, LOW(T1_fr_s)
		ld temp1, X
		
		cpi temp, 0x00
		brne T1_running	;    1   , 
		cpi temp1, 0x00
		brne T1_running   ;    1   , 
		;  1 ,   ,   
		;   
		cbi PORTB, 4	; 1 
		
		ldi XH, HIGH(Current_timer)
		ldi XL, LOW(Current_timer)
		ldi temp, 0x02
		st X, temp		;   = 2
		;    2
	jmp T2_start
		   		
T1_running:
	;,      
	sbis PIND, 7
   jmp Emergency_stop
jmp T1_start
;*******************************************************

T2_start:
	sbi PORTB, 5 ;(.  2)
	;    2

		ldi XH, HIGH(T2_wh_s)
		ldi XL, LOW(T2_wh_s)
		ld temp, X
		
		ldi XH, HIGH(T2_fr_s)
		ldi XL, LOW(T2_fr_s)
		ld temp1, X
		
		cpi temp, 0x00
		brne T2_running	;    2   , 
		cpi temp1, 0x00
		brne T2_running   ;    2   , 
		;  2 ,   ,   
		;   
		cbi PORTB, 5	; 2 
		
		ldi XH, HIGH(Current_timer)
		ldi XL, LOW(Current_timer)
		ldi temp, 0x03
		st X, temp		;   = 3
		;    3
	jmp T3_start
		   		
T2_running:
	;,      
	sbis PIND, 7
   jmp Emergency_stop
jmp T2_start
;*******************************************************

T3_start:
cbi PORTB, 6 ;(.  3)
	;    3
		ldi XH, HIGH(T3_wh_s)
		ldi XL, LOW(T3_wh_s)
		ld temp, X
		
		ldi XH, HIGH(T3_fr_s)
		ldi XL, LOW(T3_fr_s)
		ld temp1, X
		
		cpi temp, 0x00
		brne T3_running	;    3   , 
		cpi temp1, 0x00
		brne T3_running   ;    3   , 
		;  3 ,   ,  
		
		sbi PORTB, 6	; 3 
		
		ldi temp, 0x00
		out TCCR1B, temp		; 
		call Invertor_3
		cbi PORTB, 6 ;(.  3)
		call Beep

		ldi XH, HIGH(Current_timer)
		ldi XL, LOW(Current_timer)
		ldi temp, 0x01
		st X, temp		;   = 1

	jmp TX_start__
		   		
T3_running:
	;,      
	sbis PIND, 7
   jmp Emergency_stop
jmp T3_start
;*******************************************************


TX_start__:
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   (   ,  . 0)

	ldi XH, HIGH(T1_wh_restore)	; 	1
	ldi XL, LOW(T1_wh_restore)
	ld temp, X
	
	ldi XH, HIGH(T1_wh_s)
	ldi XL, LOW(T1_wh_s)
	st X, temp
	
	ldi XH, HIGH(T1_fr_restore)   ;	.1
	ldi XL, LOW(T1_fr_restore)
	ld temp, X
	
	ldi XH, HIGH(T1_fr_s)
	ldi XL, LOW(T1_fr_s)
	st X, temp


	ldi XH, HIGH(T2_wh_restore)	; 	2
	ldi XL, LOW(T2_wh_restore)
	ld temp, X
	
	ldi XH, HIGH(T2_wh_s)
	ldi XL, LOW(T2_wh_s)
	st X, temp
	
	ldi XH, HIGH(T2_fr_restore)   ;	.2
	ldi XL, LOW(T2_fr_restore)
	ld temp, X
	
	ldi XH, HIGH(T2_fr_s)
	ldi XL, LOW(T2_fr_s)
	st X, temp


	ldi XH, HIGH(T3_wh_restore)	; 	3
	ldi XL, LOW(T3_wh_restore)
	ld temp, X
	
	ldi XH, HIGH(T3_wh_s)
	ldi XL, LOW(T3_wh_s)
	st X, temp
	
	ldi XH, HIGH(T3_fr_restore)   ;	.3
	ldi XL, LOW(T3_fr_restore)
	ld temp, X
	
	ldi XH, HIGH(T3_fr_s)
	ldi XL, LOW(T3_fr_s)
	st X, temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

jmp ready

; 
Emergency_stop:
; 
cbi PORTB, 4
cbi PORTB, 5
cbi PORTB, 6
cbi PORTB, 7

	ldi temp, 0x00
	out TCCR1B, temp		; 
;

jmp ready
	
;*******************************************************
forever:
   nop
   nop       ; Infinite loop.
   nop       ; Define your main system
   nop       ; behaviour here
rjmp forever

;*******************************************************
;*******************************************************
Decr_current_timer:
;      1 ( 0,1 .)
push temp
;  1
	ldi temp, 0xCF
	out TCNT1H, temp
	ldi temp, 0x2B
	out TCNT1L, temp
;
push temp1
push data
push XL
push XH

	ldi XH, HIGH(Current_timer)
	ldi XL, LOW(Current_timer)
	ld temp, X
dc_1:	
	cpi temp, 0x01
	brne dc_2
	call Decr_T1sbr
	
dc_2:
	cpi temp, 0x02
	brne dc_3
	call Decr_T2sbr
	

dc_3:
	cpi temp, 0x03
	brne dc__
	call Decr_T3sbr
	
dc__:

pop XH
pop XL
pop data
pop temp1
pop temp
reti
;*******************************************************

;  
Read_keys:
	in temp, PIND 	;   
;	call delay		; - for simulation only
	call ldelay    ; - in real device
	in temp1, PIND ;    
	cp temp, temp1 ;     
	brne not_equ   ;   
	mov data, temp ;
ret
not_equ:
	ldi data, 0x00 ; 0
ret

; 
delay:
	push temp
	ldi temp, 0xFF
del_1:
	dec temp
	cpi temp, 0x00
	brne del_1
	pop temp
ret

ldelay:
	push temp
	ldi temp, 0xFF
ldel_1:
	push temp
	call delay
	pop temp
	dec temp
	brne ldel_1
pop temp
ret
	


;   0    
Disp_drive:

	push temp
	in temp, SREG
	push temp
	push temp1
	push data
	push XL
	push XH
;  
	ldi temp, 0xFF
	out PORTA, temp
;      
	ldi XH, HIGH(Current_timer)
	ldi XL, LOW(Current_timer)
   ld temp, X
;      
	ldi XH, HIGH(Current_cycle)
	ldi XL, LOW(Current_cycle)
	ld index, X
;        
;.   . 
tim1:
	cpi temp, 0x01
	brne tim2
   	ldi XH, HIGH(T1_wh_s)	;     . 
   	ldi XL, LOW(T1_wh_s)
   	ld whole, X
   	
   	ldi XH, HIGH(T1_fr_s)   ;     . 
   	ldi XL, LOW(T1_fr_s)
   	ld fract, X
   	
   	jmp tim__
   	
tim2:
	cpi temp, 0x02
	brne tim3
   	ldi XH, HIGH(T2_wh_s)
   	ldi XL, LOW(T2_wh_s)
   	ld whole, X
   	
   	ldi XH, HIGH(T2_fr_s)
   	ldi XL, LOW(T2_fr_s)
   	ld fract, X
   	
   	jmp tim__
tim3:
	cpi temp, 0x03
	brne tim__
   	ldi XH, HIGH(T3_wh_s)
   	ldi XL, LOW(T3_wh_s)
   	ld whole, X
   	
   	ldi XH, HIGH(T3_fr_s)
   	ldi XL, LOW(T3_fr_s)
   	ld fract, X
   	
   	
tim__:

;   
digit_0:
	cpi index, 0x00	;(  !!!!)
	brne digit_1
   	;      
      ;  . 0   
      	ldi ZH, HIGH(2*Digits)
      	ldi ZL, LOW(2*Digits)
      		ldi temp, 0x00
      		add ZL, fract
      		adc ZH, temp      		
      	lpm temp, Z
      	out PORTA, temp
      	in temp, PORTB    ;         
      							;   ,  !
      	andi temp, 0xFE
      	ori temp, 0x0E
      	out PORTB, temp
      	
      	; 
      	inc index
      	jmp digit__	
      	
digit_1:
	cpi index, 0x01
	brne digit_2
		;  
			andi whole, 0x0F	;   (Format Packed BCD)
			ldi ZH, HIGH(2*Digits)
      	ldi ZL, LOW(2*Digits)
      		ldi temp, 0x00
      		add ZL, whole
      		adc ZH, temp      		
      	lpm temp, Z
      	out PORTA, temp
      	in temp, PORTB    ;         
      							;   ,  !
      	andi temp, 0xFD
      	ori temp, 0x0D
      	out PORTB, temp

      	; 
      	inc index
      	jmp digit__

digit_2:
	cpi index, 0x02
	brne digit_3
		;  
			andi whole, 0xF0	;   (Format Packed BCD)
			swap whole
			ldi ZH, HIGH(2*Digits)
      	ldi ZL, LOW(2*Digits)
      		ldi temp, 0x00
      		add ZL, whole
      		adc ZH, temp      		
      	lpm temp, Z
      	out PORTA, temp
      	in temp, PORTB    ;         
      							;   ,  !
      	andi temp, 0xFB
      	ori temp, 0x0B
      	out PORTB, temp
      	
      	; 
      	inc index
      	jmp digit__

digit_3:
	cpi index, 0x03
	brne digit__
      ;  
;     
	ldi XH, HIGH(Current_timer)
	ldi XL, LOW(Current_timer)
   ld temp1, X
   		ldi temp, 0x00
   		ldi ZH, HIGH(2*Digits)
      	ldi ZL, LOW(2*Digits)
      		add ZL, temp1
      		adc ZH, temp      		
      	lpm temp, Z
      	out PORTA, temp
      	in temp, PORTB    ;         
      							;   ,  !
      	andi temp, 0xF7
      	ori temp, 0x07
      	out PORTB, temp

		; 
     	inc index
digit__:
	;   3,  
	cpi index, 0x04
	brlo nextt
   ldi index, 0x00
nextt:
	ldi XH, HIGH(Current_cycle)
	ldi XL, LOW(Current_cycle)
	st X, index							; 
	
   pop XH
   pop XL
	pop data
	pop temp1
	pop temp
	out SREG, temp
	pop temp
reti

;++++++++++++++++++++++++++++++++++++++++++++
;       . +1
incr_T1sbr:
push temp
   ldi XH, HIGH(Current_timer)
   ldi XL, LOW(Current_timer)
   ldi temp, 0x01
   st X, temp						;  

	ldi XH, HIGH(T1_fr_s)
	ldi XL, LOW(T1_fr_s)
	ld temp, X
	
	inc temp
	cpi temp, 0x0A
	brne in_t1_1
		ldi temp, 0x00
		st X, temp
		
		ldi XH, HIGH(T1_wh_s)
		ldi XL, LOW(T1_wh_s)
		ld temp, X
		inc temp
			mov temp1, temp
			andi temp1, 0x0F
			cpi temp1, 0x0A
			brne in_t1_2
			
			dec temp
			andi temp, 0xF0
			swap temp
			inc temp
				cpi temp, (up+1)
				brne in_t1_4
				ldi temp, 0x00
		in_t1_4:		
			swap temp
		in_t1_2:
		st X, temp		; 
		;   
		; 
      jmp in_t1_3
		
in_t1_1:
	st X, temp	; 
in_t1_3:
pop temp
ret
;++++++++++++++++++++++++++++++++++++++++++++

;++++++++++++++++++++++++++++++++++++++++++++
decr_T1sbr:
push temp
   ldi XH, HIGH(Current_timer)
   ldi XL, LOW(Current_timer)
   ldi temp, 0x01
   st X, temp						;  

	ldi XH, HIGH(T1_fr_s)
	ldi XL, LOW(T1_fr_s)
	ld temp, X
	dec temp
	cpi temp, 0xFF
	brne de_t1_1
		ldi temp, 0x09
		st X, temp
		
		ldi XH, HIGH(T1_wh_s)
		ldi XL, LOW(T1_wh_s)
		ld temp, X
		dec temp
			mov temp1, temp
			andi temp1, 0x0F
			cpi temp1, 0x0F
			brne de_t1_2
						
			   andi temp, 0xF0
			   ori temp, 0x09
			   	mov temp1, temp
			   	andi temp1, 0xF0
			   	cpi temp1, 0xF0
			   	brne de_t1_4
			   	ldi temp, 0x00
				
			de_t1_4:
			
		de_t1_2:
		st X, temp
		jmp de_t1_3

de_t1_1:
	st X, temp
de_t1_3:
pop temp
ret
;++++++++++++++++++++++++++++++++++++++++++++

;++++++++++++++++++++++++++++++++++++++++++++
incr_T2sbr:
push temp
   ldi XH, HIGH(Current_timer)
   ldi XL, LOW(Current_timer)
   ldi temp, 0x02
   st X, temp						;  

  	ldi XH, HIGH(T2_fr_s)
	ldi XL, LOW(T2_fr_s)
	ld temp, X
	
	inc temp
	cpi temp, 0x0A
	brne in_t2_1
		ldi temp, 0x00
		st X, temp
		
		ldi XH, HIGH(T2_wh_s)
		ldi XL, LOW(T2_wh_s)
		ld temp, X
		inc temp
			mov temp1, temp
			andi temp1, 0x0F
			cpi temp1, 0x0A
			brne in_t2_2
			
			dec temp
			andi temp, 0xF0
			swap temp
			inc temp
				cpi temp, (up+1)
				brne in_t2_4
				ldi temp, 0x00
		in_t2_4:
			swap temp
		in_t2_2:
		st X, temp		; 
		;   
		; 
      jmp in_t2_3
		
in_t2_1:
	st X, temp	; 
in_t2_3:
pop temp
ret
;++++++++++++++++++++++++++++++++++++++++++++

;++++++++++++++++++++++++++++++++++++++++++++
decr_T2sbr:
push temp
   ldi XH, HIGH(Current_timer)
   ldi XL, LOW(Current_timer)
   ldi temp, 0x02
   st X, temp						;  

	ldi XH, HIGH(T2_fr_s)
	ldi XL, LOW(T2_fr_s)
	ld temp, X
	dec temp
	cpi temp, 0xFF
	brne de_t2_1
		ldi temp, 0x09
		st X, temp
		
		ldi XH, HIGH(T2_wh_s)
		ldi XL, LOW(T2_wh_s)
		ld temp, X
		dec temp
			mov temp1, temp
			andi temp1, 0x0F
			cpi temp1, 0x0F
			brne de_t2_2
			
			andi temp, 0xF0
			ori temp, 0x09
			   	mov temp1, temp
			   	andi temp1, 0xF0
			   	cpi temp1, 0xF0
			   	brne de_t2_4
			   	ldi temp, 0x00
				
			de_t2_4:			

		de_t2_2:
		st X, temp
		jmp de_t2_3

de_t2_1:
	st X, temp
de_t2_3:
pop temp
ret
;++++++++++++++++++++++++++++++++++++++++++++

;++++++++++++++++++++++++++++++++++++++++++++
incr_T3sbr:
push temp
   ldi XH, HIGH(Current_timer)
   ldi XL, LOW(Current_timer)
   ldi temp, 0x03
   st X, temp						;  

  	ldi XH, HIGH(T3_fr_s)
	ldi XL, LOW(T3_fr_s)
	ld temp, X
	
	inc temp
	cpi temp, 0x0A
	brne in_t3_1
		ldi temp, 0x00
		st X, temp
		
		ldi XH, HIGH(T3_wh_s)
		ldi XL, LOW(T3_wh_s)
		ld temp, X
		inc temp
			mov temp1, temp
			andi temp1, 0x0F
			cpi temp1, 0x0A
			brne in_t3_2
			
			dec temp
			andi temp, 0xF0
			swap temp
			inc temp
				cpi temp, (up+1)
				brne in_t3_4
				ldi temp, 0x00
		in_t3_4:
			swap temp
		in_t3_2:
		st X, temp		; 
		;   
		; 
      jmp in_t3_3
		
in_t3_1:
	st X, temp	; 
in_t3_3:
; ,    
ldi flag, 0x01
pop temp
ret
;++++++++++++++++++++++++++++++++++++++++++++

;++++++++++++++++++++++++++++++++++++++++++++
decr_T3sbr:
push temp
   ldi XH, HIGH(Current_timer)
   ldi XL, LOW(Current_timer)
   ldi temp, 0x03
   st X, temp						;  

	ldi XH, HIGH(T3_fr_s)
	ldi XL, LOW(T3_fr_s)
	ld temp, X
	dec temp
	cpi temp, 0xFF
	brne de_t3_1
		ldi temp, 0x09
		st X, temp
		
		ldi XH, HIGH(T3_wh_s)
		ldi XL, LOW(T3_wh_s)
		ld temp, X
		dec temp
			mov temp1, temp
			andi temp1, 0x0F
			cpi temp1, 0x0F
			brne de_t3_2
			
		   andi temp, 0xF0
		   ori temp, 0x09
		   	mov temp1, temp
		   	andi temp1, 0xF0
		   	cpi temp1, 0xF0
		   	brne de_t3_4
		   	ldi temp, 0x00
				
			de_t3_4:
			
		de_t3_2:
		st X, temp
		jmp de_t3_3

de_t3_1:
	st X, temp
de_t3_3:
pop temp
ret
;++++++++++++++++++++++++++++++++++++++++++++

;   
;  0   500 
; Tbeep 
Beep:
;
	ldi temp, 0x00
	out TCCR0, temp
	ldi temp, 0xFF
	out PORTA, temp
;
	
	ldi temp, (Tbeep*4)
B_cycle:
	push temp
	
		ldi temp, 0xFF
		B_c_1:
			push temp
				call Delay
				in temp, PORTC
				sbrc temp, 0
					cbi PORTC, 0
				sbrs temp, 0
			      sbi PORTC, 0
			pop temp
			dec temp
			brne B_c_1
				
	pop temp
	dec temp
	brne B_cycle
;

	ldi temp, (1<<CS01)
	out TCCR0, temp		;  0
;	
ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;     3  Tbeep 

Invertor_3:

ldi temp, 0x00    	;   
out TCCR0, temp   	;    0
			;   ,     ,   :
;out PORTA, temp 	;  
			;     ,       , . .
ldi temp, 0xFF
out PORTA, temp 	;    ,   

ldi temp, (4*Invertor_time) 	;  4,       1/4 ,  
				;      4 
B_taim: 			;   
	push temp 			;      
	ldi temp, 0xFA 			;         (250)
B_taim_1:
	push temp 			; .  -  .   
	call Delay 			;    1
	pop temp 			;     . 
	dec temp 			;
	brne B_taim_1 			;
	pop temp 			;    . 
	dec temp 			;  
	brne B_taim 			;    ,   

	;ldi temp, (1<< out TCCR0, temp)
	ret

;------------------------------------------------------------

;   
Timer_restore:	
	
	ldi XH, HIGH(T1_wh_s)			;	1
	ldi XL, LOW(T1_wh_s)
	ld temp, X

	ldi XH, HIGH(T1_wh_restore)	
	ldi XL, LOW(T1_wh_restore)
	st X, temp
	
	ldi XH, HIGH(T1_fr_s)			;	.1
	ldi XL, LOW(T1_fr_s)
	ld temp, X

	ldi XH, HIGH(T1_fr_restore)	
	ldi XL, LOW(T1_fr_restore)
	st X, temp


	ldi XH, HIGH(T2_wh_s)			;	2
	ldi XL, LOW(T2_wh_s)
	ld temp, X

	ldi XH, HIGH(T2_wh_restore)	
	ldi XL, LOW(T2_wh_restore)
	st X, temp
	
	ldi XH, HIGH(T2_fr_s)			;	.2
	ldi XL, LOW(T2_fr_s)
	ld temp, X

	ldi XH, HIGH(T2_fr_restore)	
	ldi XL, LOW(T2_fr_restore)
	st X, temp


	ldi XH, HIGH(T3_wh_s)			;	3
	ldi XL, LOW(T3_wh_s)
	ld temp, X

	ldi XH, HIGH(T3_wh_restore)	
	ldi XL, LOW(T3_wh_restore)
	st X, temp
	
	ldi XH, HIGH(T3_fr_s)			;	.3
	ldi XL, LOW(T3_fr_s)
	ld temp, X

	ldi XH, HIGH(T3_fr_restore)	
	ldi XL, LOW(T3_fr_restore)
	st X, temp
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



;      
Digits: .DB 0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xF8, 0x80, 0x90
;				0		1		2		3		4		5		6		7		8		9

;,     
.DSEG
T1_wh_s:	.BYTE 1	;  (0-30)  1
T1_fr_s:	.BYTE 1	;  (0-0,9)  1
T2_wh_s:	.BYTE 1	;  (0-30)  2
T2_fr_s:	.BYTE 1	;  (0-0,9)  2
T3_wh_s:	.BYTE 1	;  (0-30)  3
T3_fr_s:	.BYTE 1	;  (0-0,9)  3

;    1-3
T1_wh_restore: .BYTE 1
T1_fr_restore: .BYTE 1
T2_wh_restore: .BYTE 1
T2_fr_restore: .BYTE 1
T3_wh_restore: .BYTE 1
T3_fr_restore: .BYTE 1

Current_timer: .BYTE 1 ; 
Current_cycle: .BYTE 1 ;  (   )

.CSEG

















